var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const type_graphql_1 = require("type-graphql");
const typeorm_1 = require("typeorm");
exports.createBaseCRUDResolver = (ObjClass) => {
    let BaseResolver = class BaseResolver {
        /**
         * createEntity
         * @param input
         */
        async createOne(input) {
            const repository = typeorm_1.getRepository(`${ObjClass.name}`);
            const insertResult = await repository.insert(input);
            return this.findOne(insertResult.identifiers[0]);
        }
        /**
         * createManyEntity
         * @param input
         */
        async createMany(input) {
            const repository = typeorm_1.getRepository(`${ObjClass.name}`);
            const insertResult = await repository.insert(input);
            return this.findMany(insertResult.identifiers);
        }
        /**
         * findEntity
         * @param where
         */
        async findOne(where) {
            const repository = typeorm_1.getRepository(`${ObjClass.name}`);
            return repository.findOne({
                where
            });
        }
        /**
         * findManyEntity
         * @param where
         */
        async findMany(where) {
            const repository = typeorm_1.getRepository(`${ObjClass.name}`);
            return repository.find({
                where
            });
        }
    };
    __decorate([
        type_graphql_1.Mutation(returns => ObjClass, { name: `create${ObjClass.name}`, nullable: true }),
        __param(0, type_graphql_1.Arg('input', type => ObjClass)),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], BaseResolver.prototype, "createOne", null);
    __decorate([
        type_graphql_1.Mutation(returns => [ObjClass], { name: `create${ObjClass.name}`, nullable: true }),
        __param(0, type_graphql_1.Arg('input', type => [ObjClass])),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], BaseResolver.prototype, "createMany", null);
    __decorate([
        type_graphql_1.Query(returns => ObjClass, { name: `find${ObjClass.name}`, nullable: true }),
        __param(0, type_graphql_1.Arg('where', type => ObjClass)),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], BaseResolver.prototype, "findOne", null);
    __decorate([
        type_graphql_1.Query(returns => [ObjClass], { name: `findMany${ObjClass.name}`, nullable: true }),
        __param(0, type_graphql_1.Arg('where', type => [ObjClass])),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], BaseResolver.prototype, "findMany", null);
    BaseResolver = __decorate([
        type_graphql_1.Resolver({ isAbstract: true })
    ], BaseResolver);
    return BaseResolver;
};
